/*
Author     :  AA-Team - http://themeforest.net/user/AA-Team
*/

// Initialization and events code for the app
Instaberg_admin = (function ($) {
	"use strict";

	// public
	var debug_level = 0,
		maincontainer = null,
		$action_status = null,
		notices_main = null,
		loading = null,
		notices_opt = {},
		file_frame, image_data, mainimage;;

	// init function, autoload
	(function init() {
		// load the triggers
		$(document).ready(function(){
			maincontainer = $(".Instaberg_iw");
			$action_status = maincontainer.find(".Instaberg-action-status.Instaberg-message");

			notices_main = $("#Instaberg-admin-mainnotices");

			triggers();

			loading = $(".Instaberg_iw-loader");

			loading.hide();

			fix_content_width();
		});

		$(window).resize(function(){
			fix_content_width();
		});
	})();

	function instagram_auth( that )
	{
		var preloader = that.parents("form").eq(0).find('.Instaberg_iw-loader');
		preloader.show();

		$.ajax({
			url: ajaxurl,
			dataType: "json",
			method: 'post',
			data: {
				action: 'Instaberg_Instagram_ajax',
				sub_action: "auth",
				params: that.parents("form").eq(0).serialize()
			},
			// Handle the successful result
			success: function( response ) {
				if( response.status == 'valid' ){
					window.location = response.redirect_url;
					return;
				}
			}
		});
	}





	function get_box_settings( str )
	{
		var regex = /\[(.*?)\]/g;

		var res = str.match(regex);

		return {
			'box' : res[1].replace("]", '').replace("[", ''),
			'option' : res[2].replace("]", '').replace("[", ''),
		};
	}

	function update( data )
	{
		maincontainer.find(".Instaberg_iw-loader").show();

		maincontainer.find(".Instaberg_iw-loader").find('span').html('');
		$.ajax({
			url: ajaxurl,
			data: $.extend(
				{
					_ajax_custom_list_nonce: $('#_ajax_custom_list_nonce').val(),
					action: $("#ajaxid").val()
				},
				data
			),
			// Handle the successful result
			success: function( response ) {

				// WP_List_Table::ajax_response() returns json
				var response = $.parseJSON( response );

				// add the requested rows
				if ( response.rows.length )
					maincontainer.find('#the-list').html( response.rows );

				// update column headers for sorting
				if ( response.column_headers.length )
					maincontainer.find('thead tr, tfoot tr').html( response.column_headers );

				// update pagination for navigation
				if ( response.pagination.bottom.length )
					maincontainer.find('.tablenav.top .tablenav-pages').html( $(response.pagination.top).html() );

				if ( response.pagination.top.length )
					maincontainer.find('.tablenav.bottom .tablenav-pages').html( $(response.pagination.bottom).html() );

				// init back our event handlers
				triggers();

				// hide the loader
				maincontainer.find(".Instaberg_iw-loader").fadeOut(250);
			}
		});
	}

	function __query( query, variable )
	{
		var vars = query.split("&");
		for ( var i = 0; i <vars.length; i++ ) {
			var pair = vars[ i ].split("=");
			if ( pair[0] == variable )
				return pair[1];
		}
		return false;
	}

	function fix_content_width()
	{
		maincontainer.css({
			'height': ( $("#wpwrap").height() - 90 )
		});
	}

	function multiselect_left2right( autselect ) {
		var $allListBtn = $('.multisel_l2r_btn');
		var autselect = autselect || false;

		if ( $allListBtn.length > 0 ) {
			$allListBtn.each(function(i, el) {

				var $this = $(el), $multisel_available = $this.prevAll('.Instaberg-multiselect-available').find('select.multisel_l2r_available'), $multisel_selected = $this.prevAll('.Instaberg-multiselect-selected').find('select.multisel_l2r_selected');

				if ( autselect ) {
					$multisel_selected.find('option').each(function() {
						$(this).prop('selected', true);
					});
					$multisel_available.find('option').each(function() {
						$(this).prop('selected', false);
					});
				} else {

				$this.on('click', '.moveright', function(e) {
					e.preventDefault();
					$multisel_available.find('option:selected').appendTo($multisel_selected);
				});
				$this.on('click', '.moverightall', function(e) {
					e.preventDefault();
					$multisel_available.find('option').appendTo($multisel_selected);
				});
				$this.on('click', '.moveleft', function(e) {
					e.preventDefault();
					$multisel_selected.find('option:selected').appendTo($multisel_available);
				});
				$this.on('click', '.moveleftall', function(e) {
					e.preventDefault();
					$multisel_selected.find('option').appendTo($multisel_available);
				});

				}
			});
		}
	}

	/* BEGIN aa-framework */
	function make_tabs()
	{
		function show_tab_elements( link, form, that )
		{
			var link_name = link.find("a").attr("href").replace("#", "");

			// hide all elements
			form.find( ".Instaberg-form-row:not(." + ( link_name ) + ")" ).hide();

			var cc = 0;
			form.find( ".Instaberg-form-row." + link_name + ", .Instaberg-message." + link_name ).each(function(){
				var that = $(this);

				that.show();

				if( cc % 2 == 0 ){
					that.addClass("Instaberg-even");
				}

				if( cc % 1 == 0 ){
					that.addClass("Instaberg-odd");
				}

				cc++;
			});

			that.find(".on").removeClass("on");
			link.addClass("on");
		}

		maincontainer.find(".Instaberg-settings-tabs").each(function(){
			var that = $(this),
				form = that.parents("form").eq(0),
				link = that.find("li").eq(0);

			show_tab_elements( link, form, that );

			that.on('click', 'li a', function(e){
				e.preventDefault();
				var link = $(this).parent("li");

				show_tab_elements( link, form, that );
			});
	   });
	}


	function saveOptions($btn)
	{
		var theForm         = $btn.parents('form').eq(0),
			value           = $btn.val(),
			statusBoxHtml   = theForm.find('div#Instaberg-status-box');

		// replace the save button value with loading message
		$btn.val(__('saving setings ...').removeClass('green').addClass('gray'));

		theForm.submit();

		// replace the save button value with default message
		$btn.val( value ).removeClass('gray').addClass('green');
	}

	function same_height( $elms )
	{
		$elms.each(function(){
			var row 		= $(this),
				maxHeight 	= 0,
				childs 		= row.find(">div .Instaberg_iw-dashboard-in-box-content");

			childs.each(function(){
				var that = $(this),
					height = that.height();

				if( maxHeight <= height ){
					maxHeight = height;
				}
			});
			if( maxHeight > 0 ) childs.height( maxHeight );
		});
	}

	function font_preview()
	{
		function change_font( preview_elm ) {
			var that = preview_elm,
				pair_element = that.parents('.Instaberg-form-item:first').find('select'),
				pair_value = pair_element.val(),
				google_font_url = "http://fonts.googleapis.com/css?family=" + pair_value;

			// step 1, load into DOM the spreadsheet
			$("head").append("<link href='" + ( google_font_url ) + "' rel='stylesheet' type='text/css'>");

			// step 2, print the font name into preview with inline font-family
			that.html( "<span style='font-family: " + ( pair_value ) + "'>Grumpy wizards make toxic brew for the evil Queen and Jack.</span>" );
		};

		$(".Instaberg-font-preview").each(function(){
			var that = $(this),
				pair_element = that.parents('.Instaberg-form-item:first').find('select');

			change_font( that );

			pair_element.change(function(e) {
				var preview = $(this).parents('.Instaberg-form-item:first').find('.Instaberg-font-preview');
				change_font( preview );
			});
		});
	};

	function register_plugin( that )
	{
		var form = that.parents('form').eq(0);

		loading.show();
		var data = {
			'action'	: 'Instaberg_register',
			'params'	: form.serialize()
		};

		$.post(ajaxurl, data, function (response) {

			if( response.status == 'valid' ){
				location.reload();
			}

			loading.hide();

		}, 'json');
	}

	function triggers()
	{
		same_height( maincontainer.find(".Instaberg_iw-section-dashboard-row") );
		make_tabs();
		multiselect_left2right();

		$("body").on( 'click', '.Instaberg-choose-template .Instaberg-the-template', function(e){
			e.preventDefault();

			var that = $(this),
				parent = that.parents('.Instaberg-choose-template'),
				select = parent.find("select"),
				key = that.data('key');

			select.val( key );

			parent.find(".Instaberg_is_selected").removeClass('Instaberg_is_selected');
			that.addClass('Instaberg_is_selected');
		});

		maincontainer.on('click', '.Instaberg-btn-new-password', function(e){
			e.preventDefault();

			new_password( $(this) );
		});

		$('body').on('click', 'button.Instaberg-add-btn', function(e){
			e.preventDefault();
			add_product( $(this) );
		});

		// bulk actions - Apply
		maincontainer.find('input#doaction').on('click', function(e) {
			e.preventDefault();

			var that = $(this),
				form = that.parents('form').eq(0),
				_action = form.find('select#bulk-action-selector-top').val();

			var field_reset = ['_ajax_custom_list_nonce', 'ajaxid', 'order', 'orderby', '_wp_http_referer'];
			for (var i in field_reset) {
				$( 'input[name="'+field_reset[i]+'"]' ).remove();
			}
			if ( 'delete' == _action ) {
				$( 'input[name="paged"]' ).val(1);
			}

			form.submit();
		});

		$('body').on('click', '.Instaberg-saveOptions', function(e) {
			e.preventDefault();
			saveOptions( $(this) );
		});

		$('body').on('click', '.Instaberg-show-all-options', function(e) {
			e.preventDefault();

			var that = $(this).parents('form').eq(0);

			that.find(".we-complex-options").removeClass('we-complex-options');
		});

		maincontainer.find('.Instaberg_iw-register_plugin').on('click', '.Instaberg_iw-dashboard-button', function(e) {
			e.preventDefault();

			register_plugin( $(this) );
		});

		maincontainer.on('click', '.Instaberg_iw-require_register', function(e){
			e.preventDefault();

			$(".Instaberg_iw-dashboard-input[name='Instaberg_iw-validation-token']").focus();
		});

		maincontainer.find('.Instaberg-select-wrapper').on('click', '.Instaberg-select-item:not(.select-on)', function(e) {
			e.preventDefault();

			var that = $(this),
				parent = that.parent();

			parent.find(".select-on").removeClass('select-on');
			parent.find("input").removeAttr("checked");

			that.addClass('select-on');
			that.find("input").attr('checked', true);
		});

		font_preview();

		maincontainer.on('click', ".Instaberg-export-now", function(e){
			e.preventDefault();

			var that = $(this),
				label = that.parents(".Instaberg-form-item").eq(0);

			loading.show();

			var data = {
				'action'	: 'Instaberg_action',
				'sub_action': 'export_settings',
				'params'	: {
				}
			};

			var url = ajaxurl;

			url += '?action=' + data.action;
			url += '&sub_action=' + data.sub_action;
			url += '&';

			var parts = [];
			$.each(data.params, function( key, value ){
				parts.push(encodeURIComponent(key) + '=' +
					encodeURIComponent(value));
			})


			url += parts.join('&');

			loading.hide();
		});


		maincontainer.on('click', ".Instaberg-btn-upload-delete", function(e){
			e.preventDefault();

			if( confirm( __("Are you sure you want to delete this image?") ) ){
				var that = $(this),
					parent = that.parents(".Instaberg-upload-box-wrapper").eq(0),
					parent_img = parent.find('.Instaberg-upload-image img');

				parent_img.remove();
				parent.find("input").val('');
			}

		});

		maincontainer.on('click', ".Instaberg-import-now", function(e){
			e.preventDefault();

			var that = $(this);

			file_frame = wp.media.frames.file_frame = wp.media({
				title: 'Insert a media',
				multiple: false,
				button: { text: __(' Load new import file ') }
			});

			file_frame.open();

			file_frame.on( 'select', function() {
				// Get media attachment details from the frame state
				var attachment = file_frame.state().get('selection').first().toJSON();

				if( !confirm( __("Are you sure you want to overwrite the campagin?") ) ){
					return true;
				}

				loading.show();

				var data = {
					'action'	: 'Instaberg_action',
					'sub_action': 'import_settings',
					'params'	: {
						'upload_id': attachment.id,
						'template_id': that.data('id')
					}
				};

				$.post(ajaxurl, data, function (response) {
					loading.hide();
					window.location.reload();
				}, 'json');

				return;
			});

			return false;
		});

		maincontainer.on('click', ".Instaberg-btn-upload", function(e){
			e.preventDefault();

			var that = $(this),
				parent = that.parents(".Instaberg-upload-box-wrapper").eq(0),
				parent_img = parent.find('.Instaberg-upload-image');

			file_frame = wp.media.frames.file_frame = wp.media({
				title: 'Insert a media',
				library: {type: 'image'},
				multiple: false,
				button: {text: __('Insert new image') }
			});

			file_frame.open();

			file_frame.on( 'select', function() {
				// Get media attachment details from the frame state
				var attachment = file_frame.state().get('selection').first().toJSON();

				var img = $("<img />"),
				input = parent.find("input");

				img.attr( 'src', attachment.sizes.thumbnail.url );
				input.val( attachment.id );

				parent_img.html( img );
			});

			return false;
		});

		maincontainer.find(".Instaberg-list-of-colors").find("ul").eq(0).sortable();

		$('body').on('click', ".Instaberg-tmdb-auth-box-header a:not(.on)", function(e){
			e.preventDefault();
			var that = $(this),
				rel = $(that.attr('href')),
				preload = $(".Instaberg-tmdb-auth-containers .Instaberg_iw-loader");

			preload.show();

			$(".Instaberg-tmdb-auth-box-header a.on").removeClass("on");
			$(".Instaberg-tmdb-tab-auth").hide();
			rel.show();

			if( that.attr('href') == '#Instaberg-tmdb-auth-tab-user' ){
				$.ajax({
					url: ajaxurl,
					dataType: "json",
					method: 'post',
					data: {
						action: 'Instaberg_Instagram_ajax',
						sub_action: "get_account"
					},
					// Handle the successful result
					success: function( response ) {
						if( response.status == 'valid' ){
							rel.html( response.html );
							preload.hide();
						}
					}
				});

			}
			else{
				preload.hide();
			}
			that.addClass('on');
		});

		if( $('.Instaberg-tmdb-auth-box-header').data('default') == 'ok' ){
			$('.Instaberg-tmdb-auth-box-header a').eq(1).click();
		}else{
			$('.Instaberg-tmdb-auth-box-header a').eq(0).click();
		}

		maincontainer.find('#Instaberg-tmdb-auth-button').on('click', function(e) {
			e.preventDefault();

			instagram_auth( $(this) );
		});

		box_apitesting();
	}

	function box_apitesting()
	{
		//:: TABS
		function show_tab_elements( link, form, that )
		{
			var link_name = link.find("a").attr("href").replace("#", "");

			// hide all elements
			form.find( ".Instaberg-tabs-content:not(." + ( link_name ) + ")" ).hide();

			var cc = 0;
			form.find( ".Instaberg-tabs-content." + link_name ).each(function(){
				var that = $(this);

				that.show();

				if( cc % 2 == 0 ){
					that.addClass("Instaberg-even");
				}

				if( cc % 1 == 0 ){
					that.addClass("Instaberg-odd");
				}

				cc++;
			});

			that.find(".on").removeClass("on");
			link.addClass("on");
		}

		maincontainer.find(".Instaberg_box_apitest .Instaberg-tabs").each(function(){
			var that = $(this),
				form = that.parents('.Instaberg_box_apitest').eq(0),
				link = that.find("li").eq(0);

			show_tab_elements( link, form, that );

			that.on('click', 'li a', function(e){
				e.preventDefault();
				var link = $(this).parent("li");

				show_tab_elements( link, form, that );
			});
		});

		//:: run & rundev buttons
		// get response
		maincontainer.on('click', ".Instaberg_box_apitest .Instaberg-action-rundev", function(e) {
			e.preventDefault();

			goto_request( $(this) );
		});

		// get response
		maincontainer.on('click', ".Instaberg_box_apitest .Instaberg-action-run", function(e) {
			e.preventDefault();

			make_request( $(this) );
		});

		function ajaxLoading(status)
		{
			if( status == 'show' ){
				loading.show();
			}
			else{
				loading.hide();
			}
		}

		function make_request( that ) {

			var data = [],
				box = that.parents('.Instaberg_box_apitest').eq(0),
				api_method = box.data('api_method');

			ajaxLoading( 'show' );

			// action
			data.push({
				name	: 'action',
				value	: 'Instaberg_InstagramApiParse'
			});

			data.push({
				name	: 'sub_action',
				value	: api_method
			});

			// asin
			data.push({
				name	: 'id',
				value	: $('#' + api_method + '_id').val()
			});

			// country
			data.push({
				name	: 'how',
				value	: 'run'
			});

			// turn the result into a query string
			data = $.param( data );

			$.ajax({
				url: ajaxurl,
				type: 'POST',
				data: data,
				dataType: 'json',
				success: function(response) {
					if( typeof response.status != 'undefined' ) {

						var pretty = '';
						if ( 'valid' == response.status ) {
							pretty = JSON.stringify( response.data, undefined, 4 );
						}
						else {
							pretty = response.msg;
						}

						box.find('.Instaberg-tabs-content.' + api_method + '_tab2 textarea').val( pretty );
						box.find('.Instaberg-tabs-content.' + api_method + '_tab1').html( response.box_visual );

						ajaxLoading( 'remove' );
					}
				}
			});
		}

		function goto_request( that ) {

			var data = [],
				box = that.parents('.Instaberg_box_apitest').eq(0),
				api_method = box.data('api_method');

			ajaxLoading( 'show' );

			// action
			data.push({
				name	: 'action',
				value	: 'Instaberg_InstagramApiParse'
			});

			data.push({
				name	: 'sub_action',
				value	: api_method
			});

			// asin
			data.push({
				name	: 'id',
				value	: $('#' + api_method + '_id').val()
			});

			// country
			data.push({
				name	: 'how',
				value	: 'rundev'
			});

			// turn the result into a query string
			data = $.param( data );

			ajaxLoading( 'remove' );

			var url = ajaxurl + '?' + data;
			var win = window.open( url, '_blank' );
			win.focus();
		}
	}

	var misc = {
		is_chrome: function() {
			return window.chrome;
		}
	}

	// external usage
	return {
		'triggers'                  : triggers,
		'make_tabs'                  : make_tabs
	}
})(jQuery);
