<?php
/**
 * Instagram API Old Class
 * http://www.aa-team.com
 * ======================
 *
 * @package		Instagram API Old Class
 * @author		Andrei Dinca, AA-Team
 * @version		1.0
 */
!defined('ABSPATH') and exit;
if (class_exists('Instaberg_Instagram_Helper') != true) {
	class Instaberg_Instagram_Helper
	{
		const VERSION = '1.0';
		
		public $country_data = array();
		
		private $instagram_endpoint = 'https://api.instagram.com';
		private $instagram_endpoint_ver = 'https://api.instagram.com/v1';
		
		public $config = array(
			"token" 		=> "",
			'client-id' 	=> '',
			'client-secret' => '',
		);
		
		private $trys = 0;
		
		/**
		 * The constructor
		 */
		public function __construct()
		{
			// create AJAX request
			add_action('wp_ajax_Instaberg_Instagram_ajax', array(
				$this,
				'ajax_requests'
			));
			
			$this->setup();
			
			$this->trys = 0; 
		}
		
		private function setup()
		{
			$token = get_option( '_Instaberg_oauth_token', true );
			
			if( $token != false && trim($token) != "" ){
				$this->config['token'] = json_decode( $token, true );
			}

			$db_settings = get_option( 'Instaberg_Plugin_Settings', true );
			if( count($db_settings) > 0 && $db_settings !== true ){
				$this->config = array_merge( $this->config, $db_settings );
			}
		}

		public function auth( $settings )
		{
			$html = array();
			
			$instagram_auth = isset($_REQUEST['instagram_auth']) ? $_REQUEST['instagram_auth'] : 'no';
			
			$html[] = '<div class="Instaberg-tmdb-auth">';
			$html[] = 	'<div class="Instaberg-tmdb-auth-box">';
			$html[] = 		'<ul class="Instaberg-tmdb-auth-box-header" data-default="' . ( $instagram_auth ) . '">';
			$html[] = 			'<li>';
			$html[] = 				'<a href="#Instaberg-tmdb-auth-tab-connect">OAuth</a>';
			$html[] = 				'<a href="#Instaberg-tmdb-auth-tab-user">Instagram User Details</a>';
			$html[] = 			'</li>';
			$html[] = 		'</ul>';
			
			$html[] = 	'<div class="Instaberg-tmdb-auth-containers">';
			
			$html[] = 		'<div class="Instaberg_iw-loader" style="display: block;"><ul class="Instaberg_iw-preloader"><li></li><li></li><li></li><li></li><li></li></ul><span></span></div>';
			
		
			$html[] = 			'<div id="Instaberg-tmdb-auth-tab-user" class="Instaberg-tmdb-tab-auth">';
			$html[] = 			'</div>';
			
			// second tab
			$html[] = 			'<div id="Instaberg-tmdb-auth-tab-connect" class="Instaberg-tmdb-tab-auth">';
			$html[] = 				'<label>
				<span>Client ID :</span>
				<input type="text" name="Instaberg_Plugin_Settings[client-id]" value="' . ( isset($settings["client-id"]) ? $settings["client-id"] : '' ) . '" placeholder="Client ID" />
				<span class="Instaberg-form-node">This ID uniquely identifies your app.</span>
			</label>';
			$html[] = 				'<label>
				<span>Client Secret :</span>
				<input type="text" name="Instaberg_Plugin_Settings[client-secret]" value="' . ( isset($settings["client-secret"]) ? $settings["client-secret"] : '' ) . '" placeholder="Client Secret" />
				<span class="Instaberg-form-node">Your secret application key.</span>
			</label>';
			$html[] = 				'<label>
				<span>Redirect URI :</span>
				<input type="text" readonly name="Instaberg_Plugin_Settings[redirect-url]" value="' . ( home_url() ) . '" />
				<span class="Instaberg-form-node">Once users grant the required permissions, we will send them to this URL.</span>
			</label>';
			$html[] = 				'<a href="#oauth-now" id="Instaberg-tmdb-auth-button">Call for oAuth</a>';
			$html[] = 				'<p>Get Client ID  and Client Secret of your app from the <a href="https://www.instagram.com/developer/clients/manage/" target="_blank" class="link-go">Manage Clients</a> page. And also the "Security / Valid redirect URIs" found on this page must match your Redirect URI setting.</p>';
			$html[] = 			'</div>';
			
			$html[] = 		'</div>';
			$html[] = 	'</div>';
			
			$html[] = '</div>';
			
			return implode( "\n", $html );
		}

		public function make_auth( $code='' )
		{
			$auth_url = $this->instagram_endpoint . '/oauth/access_token/';

			$response = wp_remote_post( $auth_url, array(
				'method' => 'POST',
				'timeout' => 45,
				'redirection' => 5,
				'httpversion' => '1.0',
				'blocking' => true,
				'headers' => array(),
				'body' => array( 
					'grant_type' => 'authorization_code',
					'code' => $code,
					'redirect_uri' => isset($this->config['redirect-url']) ? $this->config['redirect-url'] : home_url(),
					'client_id' => $this->config['client-id'],
					'client_secret' => $this->config['client-secret']
				),
				'cookies' => array()
			));
			//var_dump('<pre>', $response , '</pre>'); echo __FILE__ . ":" . __LINE__;die . PHP_EOL;

			if( isset($response['response']['message']) && $response['response']['message'] == 'OK' ){
				if( isset($response['body']) && trim($response['body']) != "" ){
					//{"access_token": "10477749256", "user": {"id": "zzz", "username": "zzz", "profile_picture": "zzz", "full_name": "zzz", "bio": "", "website": "", "is_business": false}}
					update_option( "_Instaberg_oauth_token", $response['body'] );
					wp_redirect( admin_url('admin.php?page=Instaberg&Instaberg_action=config&instagram_auth=ok'), 302 );
					exit;
				}
			}
			else{

				$msg = array();
				$error_obj = json_decode( $response['body'], true );
				if( $error_obj == false ){
					$msg[] = "<p>Unable to get a valid response from Instagram API</p>";
				}else{
					$msg[] = "<p>";
					$msg[] = 	"<strong>" . ( $error_obj['error'] ) . "</strong>:";
					$msg[] = 	$error_obj['error_description'];
					$msg[] = "</p>";
				}
				
			}
			
			die( implode("\n", $msg ) );
		}

		public function re_auth_api_client( $old_method='' )
		{
			//var_dump('<pre>',$this->config['token'],'</pre>'); 
			$args = array(
				'method' => 'POST',
				'timeout' => 45,
				'redirection' => 5,
				'httpversion' => '1.0',
				'blocking' => true,
				'headers' => array(),
				'body' => array( 
					'grant_type' => 'refresh_token',
					'refresh_token' => $this->config['token']["refresh_token"],
					'client_id' => $this->config['client-id'],
					'client_secret' => $this->config['client-secret']
				),
				'cookies' => array()
			);
			
			$auth_url = $this->instagram_endpoint . '/oauth/access_token/';
			
			$response = wp_remote_post( $auth_url, $args );
 
			if( isset($response['response']['message']) && $response['response']['message'] == 'OK' ){
				if( isset($response['body']) && trim($response['body']) != "" ){
					$response_object = json_decode( $response['body'], true );
					 
					$token = get_option( '_Instaberg_oauth_token', true );
					$token_obj = json_decode( $token, true );
					$token_obj['old_access_token'] = $token_obj['access_token'];
					$token_obj['access_token'] = $response_object['access_token'];
					update_option( '_Instaberg_oauth_token', json_encode( $token_obj ) );
					$this->setup();
					
					return $this->call_instagram_api( $old_method );
				}
			}  
		}
		
		public function call_instagram_api( $method = '' )
		{
			$this->trys++;
			
			if( $this->trys == 3 ){
				die( "Too many requests!" );
			}
			
			if( count($this->config['token']) > 0 ){
				
				$api_url = $this->instagram_endpoint_ver . $method;
				$api_url .= "?access_token=" . $this->config['token']['access_token'];
				//var_dump('<pre>', $api_url , '</pre>'); echo __FILE__ . ":" . __LINE__;die . PHP_EOL;

				$response = wp_remote_get($api_url, array(
					'user-agent' => 'Instaberg Wordpress Plugin',
					//'headers' => array(
					//	'Authorization' => 'Bearer ' . $this->config['token']['access_token'],
					//),
				));
				//var_dump('<pre>',$api_url, $this->config['token'], $response,'</pre>');  

				if( isset($response['response']['message']) && $response['response']['message'] == 'OK' ){
					if( isset($response['body']) && trim($response['body']) != "" ){
						$response_obj = json_decode( $response['body'], true );
						return $response_obj;
					}
				}
				else{
					//var_dump('<pre>',$response,'</pre>'); die;  
					$msg = array();
					$error_obj = json_decode( $response['body'], true );
					//var_dump('<pre>',$error_obj,'</pre>');  
					if( $error_obj == false ){
						//$msg[] = "<p>Unable to get a valid response from Instagram API</p>";
					}else{ 
						if( $error_obj['error'] == 'forbidden' ){
							
							return $this->re_auth_api_client( $method );
						}
					}
				}
			}
		} 
		
		private function print_account_details()
		{
			$html = array();
			
			$arr = $this->call_instagram_api( '/users/self/' );
			//var_dump('<pre>', $arr , '</pre>'); echo __FILE__ . ":" . __LINE__;die . PHP_EOL;

			$arr = isset($arr['data']) ? $arr['data'] : array();

			if ( is_array($arr) && ! empty($arr) ) {
				
				// update account details into db
			
				$html[] = '<table class="Instaberg-tmdb-user-summary">';
				$html[] = 	'<tr>';
				$html[] = 		'<td width="100" valign="top"><img src="' . ( $arr['profile_picture'] ) . '" /></td>';
				$html[] = 		'<td>';
				
				/*unset( $arr['account']['image'] );
				foreach ($arr['account'] as $key => $value) {
					
					if( $key == 'available_earnings' )  $value = '$' . $value;
					if( $key == 'total_deposits' )  $value = '$' . $value;
					if( $key == 'balance' )  $value = '$' . $value;
					
					$alias = ucfirst($key);
					$alias = str_replace( "_", " ", $alias );
					$html[] = '<p><span>' . ( $alias ) . ':</span> <strong>' . ( $value ) . '</strong></p>';
				}*/
				$html[] = '<p><span>' . ( 'username' ) . ':</span> <strong>' . ( $arr['username'] ) . '</strong></p>';
				
				$html[] = 		'</td>';
				$html[] = 	'</tr>';
				$html[] = '</table>';
			}
			
			return implode( "\n", $html );
		}
		
		public function ajax_requests()
		{
			$action = isset($_REQUEST['sub_action']) ? $_REQUEST['sub_action'] : 'none';

			if( $action == 'auth' ){
				parse_str($_REQUEST['params'], $params);
				
				if( isset($params['box_id']) && count($params[$params['box_id']]) ){
					update_option( $params['box_id'], $params[$params['box_id']] );
				}

				$redirect_uri = $this->instagram_endpoint . '/oauth/authorize?'
					. 'response_type=code'
					. '&client_id=' . ( trim($params[$params['box_id']]['client-id']) )
					. '&redirect_uri=' . $params[$params['box_id']]['redirect-url'];
				//var_dump('<pre>', $redirect_uri , '</pre>'); echo __FILE__ . ":" . __LINE__;die . PHP_EOL;

				die(json_encode(array(
					'status' => 'valid',
					'redirect_url' => $redirect_uri,
				)));
			}

			if( $action == 'get_account' ){
				
				die(json_encode(array(
					'status' => 'valid',
					'html'	=> $this->print_account_details()
				)));   
			}
			
			die('Error');
		}
	}
}
